
#line 528 "/usr/lib64/perl5/PDL/PP.pm"
/*
 * THIS FILE WAS GENERATED BY PDL::PP! Do not modify!
 */

#define PDL_COMMENT(comment)
PDL_COMMENT("This preprocessor symbol is used to add commentary in the PDL  ")
PDL_COMMENT("autogenerated code. Normally, one would use typical C-style    ")
PDL_COMMENT("multiline comments (i.e. /* comment */). However, because such ")
PDL_COMMENT("comments do not nest, it's not possible for PDL::PP users to   ")
PDL_COMMENT("comment-out sections of code using multiline comments, as is   ")
PDL_COMMENT("often the practice when debugging, for example. So, when you   ")
PDL_COMMENT("see something like this:                                       ")
PDL_COMMENT("                                                               ")
                PDL_COMMENT("Memory access")
PDL_COMMENT("                                                               ")
PDL_COMMENT("just think of it as a C multiline comment like:                ")
PDL_COMMENT("                                                               ")
PDL_COMMENT("   /* Memory access */                                         ")

#define PDL_FREE_CODE(trans, destroy, comp_free_code, ntpriv_free_code) \
    if (destroy) { \
	comp_free_code \
    } \
    if ((trans)->dims_redone) { \
	ntpriv_free_code \
    }

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "pdl.h"
#include "pdlcore.h"
#define PDL PDL_IO_Image
extern Core* PDL; PDL_COMMENT("Structure hold core C functions")
#line 38 "Image.xs"

#include <FreeImage.h>

typedef struct img_struct {
  FIBITMAP *dib;
  int id;
} *PDL__IO__Image;

FREE_IMAGE_FORMAT _sv2fif(SV *f)
{
  int i;
  if (f == NULL) return FIF_UNKNOWN;
  if (!SvOK(f)) return FIF_UNKNOWN;
  if (SvIOK(f)) {
    i = SvIV(f);
    if (FreeImage_IsPluginEnabled((FREE_IMAGE_FORMAT)i)) return (FREE_IMAGE_FORMAT)i;
  }
  if (SvPOK(f)) {
    return FreeImage_GetFIFFromFormat(SvPV_nolen(f));
  }
  return FIF_UNKNOWN;
}

FREE_IMAGE_TYPE _sv2fit(SV *f)
{
  int i;
  if (f == NULL) return FIT_UNKNOWN;
  if (!SvOK(f)) return FIT_UNKNOWN;
  if (SvIOK(f)) {
    i = SvIV(f);
    if ( i == FIT_BITMAP  ||
         i == FIT_UINT16  ||
         i == FIT_INT16   ||
         i == FIT_UINT32  ||
         i == FIT_INT32   ||
         i == FIT_FLOAT   ||
         i == FIT_DOUBLE  ||
         i == FIT_COMPLEX ||
         i == FIT_RGB16   ||
         i == FIT_RGBA16  ||
         i == FIT_RGBF    ||
         i == FIT_RGBAF ) return (FREE_IMAGE_TYPE)i;
  }
  if (SvPOK(f)) {
    char *name = SvPV_nolen(f);
    if (memEQ(name, "BITMAP",  6)) return FIT_BITMAP;
    if (memEQ(name, "UINT16",  6)) return FIT_UINT16;
    if (memEQ(name, "INT16",   5)) return FIT_INT16;
    if (memEQ(name, "UINT32",  6)) return FIT_UINT32;
    if (memEQ(name, "INT32",   5)) return FIT_INT32;
    if (memEQ(name, "FLOAT",   5)) return FIT_FLOAT;
    if (memEQ(name, "DOUBLE",  6)) return FIT_DOUBLE;
    if (memEQ(name, "COMPLEX", 7)) return FIT_COMPLEX;
    if (memEQ(name, "RGB16",   5)) return FIT_RGB16;
    if (memEQ(name, "RGBA16",  6)) return FIT_RGBA16;
    if (memEQ(name, "RGBF",    4)) return FIT_RGBF;
    if (memEQ(name, "RGBAF",   5)) return FIT_RGBAF;
  }
  return FIT_UNKNOWN;
}

void _pdl2imparams(pdl *pix, pdl *pal, FREE_IMAGE_TYPE *fit, unsigned *width, unsigned *height, int *bpp, int *palsize)
{
  int ty = -1, di = -1;
  PDL_Indx i, n;
  PDL_Byte *bptr = NULL, bmax = 0;
  *fit = FIT_UNKNOWN;
  *bpp = 0;
  *palsize = 0;

  if (pix == NULL) return;

  ty = pix->datatype;
  di = pix->ndims;

  if (pal != NULL) {
    if ( pal->datatype == PDL_B &&
         pal->ndims == 2 &&
         pal->dims[0] == 3 &&
         pal->dims[1] > 0 &&
         pal->dims[1] <= 256 ) *palsize = pal->dims[1];
    if (*palsize == 0) {
      warn("wrong palette piddle, has to be Byte[3, n] (0 < n <= 256)");
    }
  }

  if (di == 2) {
    *width  = pix->dims[0];
    *height = pix->dims[1];
    n = pix->dims[0] * pix->dims[1];
    if (ty == PDL_D ) { *bpp = 64; *fit = FIT_DOUBLE; }
    if (ty == PDL_F ) { *bpp = 32; *fit = FIT_FLOAT;  }
    if (ty == PDL_L ) { *bpp = 32; *fit = FIT_INT32;  }
    if (ty == PDL_LL) { *bpp = 32; *fit = FIT_UINT32; } /* XXX hack: using INT64 for UINT32 */
    if (ty == PDL_S ) { *bpp = 16; *fit = FIT_INT16;  }
    if (ty == PDL_US) { *bpp = 16; *fit = FIT_UINT16; }
    if (ty == PDL_B ) {
      *fit = FIT_BITMAP;
      /* bpp detection based on max used values */
      for(bptr=(PDL_Byte *)pix->data, i=0; i<n; i++) { if(bptr[i]>bmax) bmax=bptr[i]; }
      if (bmax < 2)          { *bpp = 1; }
      else if (bmax < 16)    { *bpp = 4; }
      else                   { *bpp = 8; }
      /* bpp correction based on palette size */
      if (*palsize > 16)     { *bpp = 8; }
      else if (*palsize > 2) { *bpp = 4; }
      else if (*palsize > 0) { *bpp = 1; }
    }
  }
  if (di == 3) {
    *width  = pix->dims[0];
    *height = pix->dims[1];
    n = pix->dims[0] * pix->dims[1] * pix->dims[2];
    if (pix->dims[2] == 3) {
      if (ty == PDL_F ) { *bpp = 96; *fit = FIT_RGBF;   }
      if (ty == PDL_US) { *bpp = 48; *fit = FIT_RGB16;  }
      if (ty == PDL_B ) { *bpp = 24; *fit = FIT_BITMAP; } /* XXX handle 16bpp */
    }
    if (pix->dims[2] == 4) {
      if (ty == PDL_F ) { *bpp =128; *fit = FIT_RGBAF;  }
      if (ty == PDL_US) { *bpp = 64; *fit = FIT_RGBA16; }
      if (ty == PDL_B ) { *bpp = 32; *fit = FIT_BITMAP; } /* XXX handle 16bpp */
    }
  }

  if (*bpp == 0) {
    warn("wrong pixel pdl, has to be: D|F|L|LL|S|US|B[w,h] F|US|B[w,h,3] F|US|B[w,h,3]");
  }
}


const char* _fit2str(FREE_IMAGE_TYPE f)
{
  if (f == FIT_BITMAP  ) return "BITMAP";
  if (f == FIT_UINT16  ) return "UINT16";
  if (f == FIT_INT16   ) return "INT16";
  if (f == FIT_UINT32  ) return "UINT32";
  if (f == FIT_INT32   ) return "INT32";
  if (f == FIT_FLOAT   ) return "FLOAT";
  if (f == FIT_DOUBLE  ) return "DOUBLE";
  if (f == FIT_COMPLEX ) return "COMPLEX";
  if (f == FIT_RGB16   ) return "RGB16";
  if (f == FIT_RGBA16  ) return "RGBA16";
  if (f == FIT_RGBF    ) return "RGBF";
  if (f == FIT_RGBAF   ) return "RGBAF";
  return "";
}

const char* _fic2str(FREE_IMAGE_COLOR_TYPE c)
{
  if (c == FIC_MINISWHITE) return "MINISWHITE";
  if (c == FIC_MINISBLACK) return "MINISBLACK";
  if (c == FIC_RGB       ) return "RGB";
  if (c == FIC_PALETTE   ) return "PALETTE";
  if (c == FIC_RGBALPHA  ) return "RGBALPHA";
  if (c == FIC_CMYK      ) return "CMYK";
  return "";
}

#include "const-c.inc"


#line 450 "/usr/lib64/perl5/PDL/PP.pm"
#include "pdlperl.h"

#define PDL_XS_PREAMBLE(nret) \
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set \
                            by pp_bless ? (CS) */ \
  HV *bless_stash = 0; \
  SV *parent = 0; \
  int   nreturn = (nret); \
  (void)nreturn; \
  PDL_COMMENT("Check if you can get a package name for this input value.  ") \
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ") \
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ") \
  do { \
    if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) { \
      parent = ST(0); \
      if (sv_isobject(parent)){ \
          bless_stash = SvSTASH(SvRV(ST(0))); \
          objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var") \
      } \
    } \
  } while (0)

static inline pdl *PDL_XS_pdlinit(pTHX_ char *objname, HV *bless_stash, SV *to_push, char *method, SV **svp) {
  dSP;
  pdl *ret;
  if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
     ret = PDL->pdlnew();
     if (!ret) PDL->pdl_barf("Error making null pdl");
     if (svp) {
       *svp = sv_newmortal();
       PDL->SetSV_PDL(*svp, ret);
       if (bless_stash) *svp = sv_bless(*svp, bless_stash);
     }
  } else {
     PUSHMARK(SP);
     XPUSHs(to_push);
     PUTBACK;
     perl_call_method(method, G_SCALAR);
     SPAGAIN;
     SV *sv = POPs;
     PUTBACK;
     ret = PDL->SvPDLV(sv);
     if (svp) *svp = sv;
  }
  return ret;
}
#define PDL_XS_PERLINIT_init() \
  PDL_XS_pdlinit(aTHX_ objname, bless_stash, sv_2mortal(newSVpv(objname, 0)), "initialize", NULL)
#define PDL_XS_PERLINIT_initsv(sv) \
  PDL_XS_pdlinit(aTHX_ objname, bless_stash, sv_2mortal(newSVpv(objname, 0)), "initialize", &sv)
#define PDL_XS_PERLINIT_copy() \
  PDL_XS_pdlinit(aTHX_ objname, bless_stash, parent, "copy", NULL)
#define PDL_XS_PERLINIT_copysv(sv) \
  PDL_XS_pdlinit(aTHX_ objname, bless_stash, parent, "copy", &sv)

#define PDL_XS_RETURN(clause1) \
    if (nreturn) { \
      if (nreturn > 0) EXTEND (SP, nreturn); \
      clause1; \
      XSRETURN(nreturn); \
    } else { \
      XSRETURN(0); \
    }

#define PDL_IS_INPLACE(in) ((in)->state & PDL_INPLACE)
#define PDL_XS_INPLACE(in, out, whichinit) \
    if (PDL_IS_INPLACE(in)) { \
        if (out ## _SV) barf("inplace input but different output given"); \
        out ## _SV = sv_newmortal(); \
        in->state &= ~PDL_INPLACE; PDL_COMMENT("unset") \
        out = in; \
        PDL->SetSV_PDL(out ## _SV,out); \
    } else \
        out = out ## _SV ? PDL_CORE_(SvPDLV)(out ## _SV) : \
          PDL_XS_PERLINIT_ ## whichinit ## sv(out ## _SV);
#line 277 "Image.xs"

Core* PDL = NULL; PDL_COMMENT("Structure hold core C functions")

MODULE = PDL::IO::Image PACKAGE = PDL PREFIX=pdl_run_

PROTOTYPES: DISABLE


MODULE = PDL::IO::Image PACKAGE = PDL::IO::Image


BOOT:
        FreeImage_Initialise(FALSE);

INCLUDE: const-xs.inc

PDL::IO::Image
new_from_file(char * class, SV * input_sv, SV *f=NULL, int flags=0, int page=0)
    CODE:
    {
        FIBITMAP *dib = NULL;
        FREE_IMAGE_FORMAT fif = _sv2fif(f);

        if(SvROK(input_sv) && SvTYPE(SvRV(input_sv)) < SVt_PVAV) {
          /* input_sv is a reference to scalar */
          SV *input = SvRV(input_sv);
          STRLEN input_len = 0;
          BYTE *input_ptr = (BYTE *)SvPVbyte(input, input_len);
          FIMEMORY *hmem = FreeImage_OpenMemory(input_ptr, input_len);

          if (!hmem) croak("FAIL: FreeImage_OpenMemory failed");
          if (fif == FIF_UNKNOWN) fif = FreeImage_GetFileTypeFromMemory(hmem, 0);
          if (fif == FIF_UNKNOWN) croak("FAIL: unknown format");

          if (page > 0) {
            FIMULTIBITMAP * multi = FreeImage_LoadMultiBitmapFromMemory(fif, hmem, flags);
            if (multi) {
              int count = FreeImage_GetPageCount(multi);
              if (page < count) {
                FIBITMAP *page_dib = FreeImage_LockPage(multi, page);
                dib = FreeImage_Clone(page_dib);
                FreeImage_UnlockPage(multi, page_dib, FALSE);
              }
              else {
                warn("invalid page index '%d' (max=%d)", page, count-1);
              }
              FreeImage_CloseMultiBitmap(multi, 0);
            }
            else {
              warn("FreeImage_OpenMultiBitmap failed");
            }
          }
          else {
            dib = FreeImage_LoadFromMemory(fif, hmem, flags);
          }
          if (dib == NULL) croak("FAIL: cannot load image");
        }
        else {
          /* input_sv is a file name */
          STRLEN flen = 0;
          char * filename = SvPV(input_sv, flen);
          if (!filename || flen<=0) croak("FAIL: invalid filename");
          if (fif == FIF_UNKNOWN) fif = FreeImage_GetFileType(filename, 0);
          if (fif == FIF_UNKNOWN) fif = FreeImage_GetFIFFromFilename(filename);
          if (fif == FIF_UNKNOWN) croak("FAIL: unknown format '%s'", filename);

          if (page > 0) {
            FIMULTIBITMAP * multi = FreeImage_OpenMultiBitmap(fif, filename, FALSE, TRUE, FALSE, flags);
            if (multi) {
              int count = FreeImage_GetPageCount(multi);
              if (page < count) {
                FIBITMAP *page_dib = FreeImage_LockPage(multi, page);
                dib = FreeImage_Clone(page_dib);
                FreeImage_UnlockPage(multi, page_dib, FALSE);
              }
              else {
                warn("invalid page index '%d' (max=%d)", page, count-1);
              }
              FreeImage_CloseMultiBitmap(multi, 0);
            }
            else {
              warn("cannot open '%s' as multi page image", filename);
            }
          }
          else {
            dib = FreeImage_Load(fif, filename, flags);
          }
          if (dib == NULL) croak("FAIL: cannot load '%s'", filename);
        }

        Newz(0, RETVAL, 1, struct img_struct);
        if (RETVAL == NULL) croak("FAIL: Newz failed");

        RETVAL->dib = dib;
    }
    OUTPUT:
        RETVAL

PDL::IO::Image
new_from_pdl(char * class, pdl * pixels, pdl * palette=NULL)
    CODE:
    {
        FIBITMAP *dib = NULL;
        FREE_IMAGE_TYPE fit = FIT_UNKNOWN;
        int bpp = 0, palsize = 0;
        unsigned w = 0, h = 0, cu = 0, i;
        PDL_Indx x, y, wxh;

        _pdl2imparams(pixels, palette, &fit, &w, &h, &bpp, &palsize);
        if (fit == FIT_UNKNOWN) croak("FAIL: invalid PDL");

        dib = FreeImage_AllocateT(fit, w, h, bpp, 0, 0, 0);
        if (dib == NULL) croak("FAIL: cannot create bitmap from PDL");

        wxh = w * h;

        switch (fit) {
          case FIT_BITMAP:      /* Standard image: 1-, 4-, 8-, 16-, 24-, 32-bit */
            if (bpp==32) {
              BYTE *pdata = pixels->data;
              for(y = 0; y < h; y++) {
                RGBQUAD *bits = (RGBQUAD*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x].rgbRed      = pdata[(h-1-y)*w + x];
                  bits[x].rgbGreen    = pdata[(h-1-y)*w + x + wxh];
                  bits[x].rgbBlue     = pdata[(h-1-y)*w + x + 2*wxh];
                  bits[x].rgbReserved = pdata[(h-1-y)*w + x + 3*wxh];
                }
              }
            }
            else if (bpp==24) {
              BYTE *pdata = pixels->data;
              for(y = 0; y < h; y++) {
                RGBTRIPLE *bits = (RGBTRIPLE*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x].rgbtRed   = pdata[(h-1-y)*w + x];
                  bits[x].rgbtGreen = pdata[(h-1-y)*w + x + wxh];
                  bits[x].rgbtBlue  = pdata[(h-1-y)*w + x + 2*wxh];
                }
              }
            }
            else if (bpp==8) {
              BYTE *pdata = pixels->data;
              for(y = 0; y < h; y++) {
                BYTE *bits = FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x] = pdata[(h-1-y)*w + x];
                }
              }
            }
            else if (bpp==4) {
              BYTE *pdata = pixels->data;
              for(y = 0; y < h; y++) {
                BYTE *bits = FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x/2] |= (pdata[(h-1-y)*w + x] & 0x0F) << 4*(1-x%2);
                }
              }
            }
            else if (bpp==1) {
              BYTE *pdata = pixels->data;
              for(y = 0; y < h; y++) {
                BYTE *bits = FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x/8] |= (pdata[(h-1-y)*w + x] & 0x01) << (7-x%8);
                }
              }
            }
            else {
              warn("FAIL: unknown bits per pixel '%d'", bpp);
            }
            break;
          case FIT_UINT16:      /* Array of unsigned short: unsigned 16-bit */
            {
              PDL_Ushort *pdata = (PDL_Ushort *) pixels->data;
              for(y = 0; y < h; y++) {
                PDL_Ushort *bits = (PDL_Ushort*)FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x] = pdata[(h-1-y)*w + x];
                }
              }
            }
            break;
          case FIT_INT16:       /* Array of short: signed 16-bit */
            {
              PDL_Short *pdata = (PDL_Short *) pixels->data;
              for(y = 0; y < h; y++) {
                PDL_Short *bits = (PDL_Short*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x] = pdata[(h-1-y)*w + x];
                }
              }
            }
            break;
          case FIT_UINT32:      /* Array of unsigned long: unsigned 32-bit */
            {
              /* XXX hack: using INT64 for UINT32 */
              PDL_LongLong *pdata = (PDL_LongLong *) pixels->data;
              for(y = 0; y < h; y++) {
                DWORD *bits = (DWORD*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x] = (DWORD)pdata[(h-1-y)*w + x];
                }
              }
            }
            break;
          case FIT_INT32:       /* Array of long: signed 32-bit */
            {
              PDL_Long *pdata = (PDL_Long *) pixels->data;
              for(y = 0; y < h; y++) {
                PDL_Long *bits = (PDL_Long*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x] = pdata[(h-1-y)*w + x];
                }
              }
            }
            break;
          case FIT_FLOAT:       /* Array of float: 32-bit IEEE floating point */
            {
              PDL_Float *pdata = (PDL_Float *) pixels->data;
              for(y = 0; y < h; y++) {
                PDL_Float *bits = (PDL_Float*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x] = pdata[(h-1-y)*w + x];
                }
              }
            }
            break;
          case FIT_DOUBLE:      /* Array of double: 64-bit IEEE floating point */
            {
              PDL_Double *pdata = (PDL_Double *) pixels->data;
              for(y = 0; y < h; y++) {
                PDL_Double *bits = (PDL_Double*)FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x] = pdata[(h-1-y)*w + x];
                }
              }
            }
            break;
          case FIT_COMPLEX:     /* Array of FICOMPLEX: 2 x 64-bit IEEE floating point */
            /* XXX not supported */
            break;
          case FIT_RGB16:       /* 48-bit RGB image: 3 x 16-bit */
            {
              PDL_Ushort *pdata = (PDL_Ushort *) pixels->data;
              for(y = 0; y < h; y++) {
                FIRGB16 *bits = (FIRGB16*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x].red   = pdata[(h-1-y)*w + x];
                  bits[x].green = pdata[(h-1-y)*w + x + wxh];
                  bits[x].blue  = pdata[(h-1-y)*w + x + 2*wxh];
                }
              }
            }
            break;
          case FIT_RGBA16:      /* 64-bit RGBA image: 4 x 16-bit */
            {
              PDL_Ushort *pdata = (PDL_Ushort *) pixels->data;
              for(y = 0; y < h; y++) {
                FIRGBA16 *bits = (FIRGBA16*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x].red   = pdata[(h-1-y)*w + x];
                  bits[x].green = pdata[(h-1-y)*w + x + wxh];
                  bits[x].blue  = pdata[(h-1-y)*w + x + 2*wxh];
                  bits[x].alpha = pdata[(h-1-y)*w + x + 3*wxh];
                }
              }
            }
            break;
          case FIT_RGBF:        /* 96-bit RGB float image: 3 x 32-bit IEEE floating point */
            {
              PDL_Float *pdata = (PDL_Float *) pixels->data;
              for(y = 0; y < h; y++) {
                FIRGBF *bits = (FIRGBF*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x].red   = pdata[(h-1-y)*w + x];
                  bits[x].green = pdata[(h-1-y)*w + x + wxh];
                  bits[x].blue  = pdata[(h-1-y)*w + x + 2*wxh];
                }
              }
            }
            break;
          case FIT_RGBAF:       /* 128-bit RGBA float image: 4 x 32-bit IEEE floating point */
            {
              PDL_Float *pdata = (PDL_Float *) pixels->data;
              for(y = 0; y < h; y++) {
                FIRGBAF *bits = (FIRGBAF*) FreeImage_GetScanLine(dib, y);
                for(x = 0; x < w; x++) {
                  bits[x].red   = pdata[(h-1-y)*w + x];
                  bits[x].green = pdata[(h-1-y)*w + x + wxh];
                  bits[x].blue  = pdata[(h-1-y)*w + x + 2*wxh];
                  bits[x].alpha = pdata[(h-1-y)*w + x + 3*wxh];
                }
              }
            }
            break;
          default:
            warn("FAIL: unknown image type '%d'", fit);
            break;
        }

        cu = FreeImage_GetColorsUsed(dib);
        if (palsize > 0 && cu > 0) {
          if (palsize > cu) palsize = cu;
          BYTE *pdata = palette->data;
          RGBQUAD *pal = FreeImage_GetPalette(dib);
          for (i = 0; i < palsize; i++) {
            pal[i].rgbRed      = pdata[i*3];
            pal[i].rgbGreen    = pdata[i*3 + 1];
            pal[i].rgbBlue     = pdata[i*3 + 2];
            pal[i].rgbReserved = 0;
          }
        }
        if (palsize > 0 && cu == 0) {
          warn("ignoring palete piddle");
        }

        Newz(0, RETVAL, 1, struct img_struct);
        if (RETVAL == NULL) croak("FAIL: Newz failed");

        RETVAL->dib = dib;
    }
    OUTPUT:
        RETVAL

PDL::IO::Image
clone(PDL::IO::Image self)
    CODE:
    {
      Newz(0, RETVAL, 1, struct img_struct);
      if (RETVAL == NULL) croak("FAIL: Newz failed");
      FIBITMAP *newdib = FreeImage_Clone(self->dib);
      if (newdib == NULL) croak("FAIL: FreeImage_Clone failed");
      RETVAL->dib = newdib;
    }
    OUTPUT:
        RETVAL

void
dump_bitmap(PDL::IO::Image self, int target_bpp=0)
    PPCODE:
    {
      SV *bmp_sv, *pal_sv;
      unsigned char *bmp = NULL, *pal = NULL;
      unsigned w, h, bpp, cu, it, sz, szp, szl, y, i;
      FIBITMAP *newdib = NULL, *b = NULL;

      /* FIRST: we need FIT_BITMAP */
      it  = FreeImage_GetImageType(self->dib);
      if (it==FIT_RGB16 || it==FIT_RGBA16 || it==FIT_RGBF || it==FIT_RGBAF) {
        newdib = FreeImage_ToneMapping(self->dib, FITMO_REINHARD05, 0, 0);
      }
      else {
        newdib = FreeImage_ConvertToType(self->dib, FIT_BITMAP, 1);
      }
      if (!newdib) {
        warn("dump_bitmap failed to convert image into a BITMAP");
        XSRETURN_UNDEF;
      }

      /* SECOND: we only want 8/24/32-bpp output */
      bpp = FreeImage_GetBPP(newdib);
      if (target_bpp!=8 && target_bpp!=24 && target_bpp!=32) target_bpp = 0;
      if (target_bpp==0 && (bpp==1 || bpp==4 || bpp==8))     target_bpp = 8;
      if (target_bpp==0 && (bpp==16 || bpp==24))             target_bpp = 24;
      if (target_bpp==0 && bpp>=32)                          target_bpp = 32;

      if (target_bpp==8 && bpp!=8) {
        /* XXX BEWARE: high-color bitmap (16, 24 or 32-bit) is converted into a greyscale bitmap */
        b = FreeImage_ConvertTo8Bits(newdib);
      }
      else if (target_bpp==24 && bpp!=24) {
        b = FreeImage_ConvertTo24Bits(newdib);
      }
      else if (target_bpp==32 && bpp!=32) {
        b = FreeImage_ConvertTo32Bits(newdib);
      }
      if (b) {
        FreeImage_Unload(newdib);
        newdib = b;
      }

      bpp = FreeImage_GetBPP(newdib);
      w   = FreeImage_GetWidth(newdib);
      h   = FreeImage_GetHeight(newdib);
      cu  = FreeImage_GetColorsUsed(newdib);
      szp = (bpp/8);    /* pixel size */
      szl = szp * w;    /* line size */
      sz  = szl * h;    /* picture size */

      if (bpp==32 || bpp==24 || bpp==8) {
        bmp_sv = NEWSV(0, sz);
        SvPOK_only(bmp_sv);
        SvCUR_set(bmp_sv, sz);
        bmp = (unsigned char *)SvPV_nolen(bmp_sv);
        for(i = 0, y = 0; y < h; y++) {
          BYTE *bits = FreeImage_GetScanLine(newdib, h-y-1);
          Copy(bits, bmp + i, szl, BYTE);
          i += szl;
        }
        XPUSHs(sv_2mortal(newSViv(w)));
        XPUSHs(sv_2mortal(newSViv(h)));
        XPUSHs(sv_2mortal(newSViv(bpp)));
        XPUSHs(sv_2mortal(bmp_sv));
        if (cu>0) {
          RGBQUAD *p = FreeImage_GetPalette(newdib);
          pal_sv = NEWSV(0, cu*3);
          SvPOK_only(pal_sv);
          SvCUR_set(pal_sv, cu*3);
          pal = (unsigned char *)SvPV_nolen(pal_sv);
          for (i = 0; i < cu; i++) {
            pal[i*3]     = (unsigned char) p[i].rgbRed;
            pal[i*3 + 1] = (unsigned char) p[i].rgbGreen;
            pal[i*3 + 2] = (unsigned char) p[i].rgbBlue;
          }
          XPUSHs(sv_2mortal(pal_sv));
        }
      }
      else {
        warn("dump_bitmap: unexpected bpp");
      }

      FreeImage_Unload(newdib);
    }

const char*
free_image_version(SV *class)
    CODE:
        RETVAL = FreeImage_GetVersion();
    OUTPUT:
        RETVAL

void
format_list(SV *class)
    PPCODE:
    {
        int i;
        for(i = 0; i < FreeImage_GetFIFCount(); i++) {
          if(FreeImage_IsPluginEnabled((FREE_IMAGE_FORMAT)i)) {
            const char *f = FreeImage_GetFormatFromFIF((FREE_IMAGE_FORMAT)i);
            XPUSHs(sv_2mortal(newSVpvn(f, strlen(f))));
          }
        }
    }

const char*
format_extension_list(SV *class, SV *f)
    CODE:
        RETVAL = FreeImage_GetFIFExtensionList(_sv2fif(f));
    OUTPUT:
        RETVAL

const char*
format_mime_type(SV *class, SV *f)
    CODE:
        RETVAL = FreeImage_GetFIFMimeType(_sv2fif(f));
    OUTPUT:
        RETVAL

const char*
format_description(SV *class, SV *f)
    CODE:
        RETVAL = FreeImage_GetFIFDescription(_sv2fif(f));
    OUTPUT:
        RETVAL

int
format_can_read(SV *class, SV *f)
    CODE:
        RETVAL = FreeImage_IsPluginEnabled(_sv2fif(f)) && FreeImage_FIFSupportsReading(_sv2fif(f));
    OUTPUT:
        RETVAL

int
format_can_write(SV *class, SV *f)
    CODE:
        RETVAL = FreeImage_IsPluginEnabled(_sv2fif(f)) && FreeImage_FIFSupportsWriting(_sv2fif(f));
    OUTPUT:
        RETVAL

int
format_can_export_type(SV *class, SV *f, SV *t)
    CODE:
        RETVAL = FreeImage_FIFSupportsExportType(_sv2fif(f), _sv2fit(t));
    OUTPUT:
        RETVAL

int
format_can_export_bpp(SV *class, SV *f, int bpp)
    CODE:
        RETVAL = FreeImage_FIFSupportsExportBPP(_sv2fif(f), bpp);
    OUTPUT:
        RETVAL

const char *
format_from_mime(SV *class, const char *mime)
    CODE:
        RETVAL = FreeImage_GetFormatFromFIF(FreeImage_GetFIFFromMime(mime));
    OUTPUT:
        RETVAL

const char *
format_from_file(SV *class, const char *filename)
    CODE:
        int fif = FreeImage_GetFileType(filename, 0);
        if (fif == FIF_UNKNOWN) fif = FreeImage_GetFIFFromFilename(filename);
        RETVAL = FreeImage_GetFormatFromFIF(fif);
    OUTPUT:
        RETVAL

const char*
get_image_type(PDL::IO::Image self)
    CODE:
        RETVAL = _fit2str(FreeImage_GetImageType(self->dib));
    OUTPUT:
        RETVAL

unsigned
get_colors_used(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_GetColorsUsed(self->dib);
    OUTPUT:
        RETVAL

unsigned
get_bpp(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_GetBPP(self->dib);
    OUTPUT:
        RETVAL

unsigned
get_width(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_GetWidth(self->dib);
    OUTPUT:
        RETVAL

unsigned
get_height(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_GetHeight(self->dib);
    OUTPUT:
        RETVAL

unsigned
get_dots_per_meter_x(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_GetDotsPerMeterX(self->dib);
    OUTPUT:
        RETVAL

void
set_dots_per_meter_x(PDL::IO::Image self, unsigned res)
    PPCODE:
        FreeImage_SetDotsPerMeterX(self->dib, res);
        XPUSHs(ST(0)); /* return self */

unsigned
get_dots_per_meter_y(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_GetDotsPerMeterY(self->dib);
    OUTPUT:
        RETVAL

void
set_dots_per_meter_y(PDL::IO::Image self, unsigned res)
    PPCODE:
        FreeImage_SetDotsPerMeterY(self->dib, res);
        XPUSHs(ST(0)); /* return self */

const char*
get_color_type(PDL::IO::Image self)
    CODE:
        RETVAL = _fic2str(FreeImage_GetColorType(self->dib));
    OUTPUT:
        RETVAL

int
is_transparent(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_IsTransparent(self->dib);
    OUTPUT:
        RETVAL

int
get_transparent_index(PDL::IO::Image self)
    CODE:
        RETVAL = FreeImage_GetTransparentIndex(self->dib);
    OUTPUT:
        RETVAL

void
set_transparent_index(PDL::IO::Image self, int index)
    PPCODE:
        FreeImage_SetTransparentIndex(self->dib, index);
        XPUSHs(ST(0)); /* return self */

void
flip_horizontal(PDL::IO::Image self)
    PPCODE:
        if(!FreeImage_FlipHorizontal(self->dib)) {
          warn("FreeImage_FlipHorizontal failed");
        }
        XPUSHs(ST(0)); /* return self */

void
flip_vertical(PDL::IO::Image self)
    PPCODE:
        if(!FreeImage_FlipVertical(self->dib)) {
          warn("FreeImage_FlipVertical failed");
        }
        XPUSHs(ST(0)); /* return self */

void
convert_image_type(PDL::IO::Image self, SV * dst_image_type, int scale_linear=1)
    PPCODE:
    {
        FREE_IMAGE_TYPE fit = _sv2fit(dst_image_type);
        if (fit == FIT_UNKNOWN) {
          warn("invalid dst_image_type");
        }
        else {
          FIBITMAP *newdib = FreeImage_ConvertToType(self->dib, fit, scale_linear);
          if (newdib) {
            if (self->dib) FreeImage_Unload(self->dib);
            self->dib = newdib;
          }
          else {
            warn("FreeImage_ConvertToType (fit=%d) failed", fit);
          }
        }
        XPUSHs(ST(0)); /* return self */
    }

void
adjust_colors(PDL::IO::Image self, double brightness=0, double contrast=0, double gamma=0, int invert=0)
    PPCODE:
        if(!FreeImage_AdjustColors(self->dib, brightness, contrast, gamma, invert)) {
          warn("FreeImage_AdjustColors failed");
        }
        XPUSHs(ST(0)); /* return self */

void
tone_mapping(PDL::IO::Image self, int tmo, double p1=0, double p2=0)
    PPCODE:
        if (tmo == FITMO_DRAGO03 || tmo == FITMO_REINHARD05 || tmo == FITMO_FATTAL02) {
          FIBITMAP *newdib = FreeImage_ToneMapping(self->dib, tmo, p1, p2);
          if (newdib) {
            if (self->dib) FreeImage_Unload(self->dib);
            self->dib = newdib;
          }
          else {
            warn("FreeImage_ToneMapping (tmp=%d) failed", tmo);
          }
        }
        else {
          warn("invalid tone mapping operator");
        }
        XPUSHs(ST(0)); /* return self */

void
rotate(PDL::IO::Image self, double angle, ...)
    PPCODE:
    {
        FIBITMAP *newdib = NULL;
        unsigned bpp = FreeImage_GetBPP(self->dib);
        FREE_IMAGE_TYPE fit = FreeImage_GetImageType(self->dib);

        if (items > 2) {
          switch(fit) {
            case FIT_BITMAP:
              switch(bpp) {
                case 8:
                  {
                    BYTE color = (BYTE)SvUV(ST(2));
                    newdib = FreeImage_Rotate(self->dib, angle, &color);
                  }
                  break;
                case 24:
                case 32:
                  {
                    RGBQUAD color = { 0, 0, 0, 0 };
                    if (items >= 3) color.rgbRed      = (BYTE)SvUV(ST(2));
                    if (items >= 4) color.rgbGreen    = (BYTE)SvUV(ST(3));
                    if (items >= 5) color.rgbBlue     = (BYTE)SvUV(ST(4));
                    if (items >= 6) color.rgbReserved = (BYTE)SvUV(ST(5));
                    newdib = FreeImage_Rotate(self->dib, angle, &color);
                  }
                  break;
                default:
                  /* warn("FAIL: do not know how to handle bpp '%d'", bpp); */
                  break;
              }
              break;
            case FIT_UINT16:
              {
                WORD color = (WORD)SvUV(ST(2));;
                newdib = FreeImage_Rotate(self->dib, angle, &color);
              }
              break;
            case FIT_RGB16:
            case FIT_RGBA16:
              {
                FIRGBA16 color = { 0, 0, 0, 0 };
                if (items >= 3) color.red   = (WORD)SvUV(ST(2));
                if (items >= 4) color.green = (WORD)SvUV(ST(3));
                if (items >= 5) color.blue  = (WORD)SvUV(ST(4));
                if (items >= 6) color.alpha = (WORD)SvUV(ST(5));
                newdib = FreeImage_Rotate(self->dib, angle, &color);
              }
              break;
            case FIT_FLOAT:
              {
                float color = (float)SvNV(ST(2));
                newdib = FreeImage_Rotate(self->dib, angle, &color);
              }
              break;
            case FIT_RGBF:
            case FIT_RGBAF:
              {
                FIRGBAF color = { 0, 0, 0, 0 };
                if (items >= 3) color.red   = (float)SvNV(ST(2));
                if (items >= 4) color.green = (float)SvNV(ST(3));
                if (items >= 5) color.blue  = (float)SvNV(ST(4));
                if (items >= 6) color.alpha = (float)SvNV(ST(5));
                newdib = FreeImage_Rotate(self->dib, angle, &color);
              }
              break;
            default:
              /* warn("FAIL: do not know how to handle image type '%d'", fit); */
              break;
          }
        }

        if (!newdib) {
          newdib = FreeImage_Rotate(self->dib, angle, NULL);
        }

        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_Rotate failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_dither(PDL::IO::Image self, int algorithm=FID_FS)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_Dither(self->dib, algorithm);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_Dither failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_threshhold(PDL::IO::Image self, unsigned threshold=127)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_Threshold(self->dib, (BYTE)threshold);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_Threshold failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_quantize(PDL::IO::Image self, int quantize=FIQ_WUQUANT)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ColorQuantize(self->dib, quantize);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ColorQuantize failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_to_4bpp(PDL::IO::Image self)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ConvertTo4Bits(self->dib);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ConvertTo4Bits failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_to_8bpp(PDL::IO::Image self)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ConvertTo8Bits(self->dib);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ConvertTo8Bits failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_to_8bpp_grey(PDL::IO::Image self)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ConvertToGreyscale(self->dib);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ConvertToGreyscale failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_to_16bpp_555(PDL::IO::Image self)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ConvertTo16Bits555(self->dib);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ConvertTo16Bits555 failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_to_16bpp_565(PDL::IO::Image self)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ConvertTo16Bits565(self->dib);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ConvertTo16Bits565 failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_to_24bpp(PDL::IO::Image self)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ConvertTo24Bits(self->dib);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ConvertTo24Bits failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
color_to_32bpp(PDL::IO::Image self)
    PPCODE:
    {
        FIBITMAP *newdib = FreeImage_ConvertTo32Bits(self->dib);
        if (newdib) {
          if (self->dib) FreeImage_Unload(self->dib);
          self->dib = newdib;
        }
        else {
          warn("FreeImage_ConvertTo32Bits failed");
        }
        XPUSHs(ST(0)); /* return self */
    }

void
rescale(PDL::IO::Image self, int dst_width=0, int dst_height=0, int filter=FILTER_CATMULLROM)
    PPCODE:
    {
        if (dst_height<=0 && dst_width>0) {
          double ratio = (double)dst_width / (double)FreeImage_GetWidth(self->dib);
          dst_height   = (int)floor(0.5 + ratio * (double)FreeImage_GetHeight(self->dib));
        }
        else if (dst_width<=0 && dst_height>0) {
          double ratio = (double)dst_height / (double)FreeImage_GetHeight(self->dib);
          dst_width    = (int)floor(0.5 + ratio * (double)FreeImage_GetWidth(self->dib));
        }
        if (dst_height>0 && dst_width>0) {
          FIBITMAP *newdib = FreeImage_Rescale(self->dib, dst_width, dst_height, filter);
          if (newdib) {
            if (self->dib) FreeImage_Unload(self->dib);
            self->dib = newdib;
          }
          else {
            warn("FreeImage_Rescale failed");
          }
        }
        XPUSHs(ST(0)); /* return self */
    }

void
rescale_pct(PDL::IO::Image self, double dst_width_pct=0, double dst_height_pct=0, int filter=FILTER_CATMULLROM)
    PPCODE:
    {
        int dst_height = (int)floor(0.5 + (double)FreeImage_GetHeight(self->dib) * dst_height_pct / 100.0);
        int dst_width  = (int)floor(0.5 + (double)FreeImage_GetWidth(self->dib)  * dst_width_pct  / 100.0);

        if (dst_height<=0 && dst_width>0) {
          double ratio = (double)dst_width / (double)FreeImage_GetWidth(self->dib);
          dst_height   = (int)floor(0.5 + ratio * (double)FreeImage_GetHeight(self->dib));
        }
        else if (dst_width<=0 && dst_height>0) {
          double ratio = (double)dst_height / (double)FreeImage_GetHeight(self->dib);
          dst_width    = (int)floor(0.5 + ratio * (double)FreeImage_GetWidth(self->dib));
        }
        if (dst_height>0 && dst_width>0) {
          FIBITMAP *newdib = FreeImage_Rescale(self->dib, dst_width, dst_height, filter);
          if (newdib) {
            if (self->dib) FreeImage_Unload(self->dib);
            self->dib = newdib;
          }
          else {
            warn("FreeImage_Rescale failed");
          }
        }
        XPUSHs(ST(0)); /* return self */
    }

void
save(PDL::IO::Image self, SV * destination, SV * f=NULL, int flags=0);
    PPCODE:
    {
        if (self->dib) {
          FIMEMORY *hmem = NULL;
          BYTE *mem_buffer = NULL;
          DWORD size_in_bytes = 0;
          FREE_IMAGE_FORMAT fif = _sv2fif(f);
          FREE_IMAGE_TYPE fit = FreeImage_GetImageType(self->dib);

          if(SvROK(destination) && SvTYPE(SvRV(destination)) < SVt_PVAV) {
            /* destination is a reference to scalar */
            SV *output = SvRV(destination);
            BYTE *output_ptr = NULL;
            if (fif == FIF_UNKNOWN) croak("FAIL: unspecified format");
            hmem = FreeImage_OpenMemory(NULL, 0);
            if (!FreeImage_SaveToMemory(fif, self->dib, hmem, flags)) {
              warn("FreeImage_SaveToMemory failed (format '%d', image type '%d')", fif, fit);
            }
            FreeImage_AcquireMemory(hmem, &mem_buffer, &size_in_bytes);
            sv_setpvn(output, "", 0);
            output_ptr = SvGROW(output, size_in_bytes);
            SvCUR_set(output, size_in_bytes);
            SvPOK_only(output);
            Copy(mem_buffer, output_ptr, size_in_bytes, BYTE);
            FreeImage_CloseMemory(hmem);
          }
          else {
            /* destination is a filename */
            STRLEN flen = 0;
            char * filename = SvPV(destination, flen);
            if (!filename || flen<=0) croak("FAIL: invalid filename");
            if (fif == FIF_UNKNOWN) fif = FreeImage_GetFIFFromFilename(filename);
            if (fif == FIF_UNKNOWN) croak("FAIL: unspecified format");
            if (!FreeImage_Save(fif, self->dib, filename, flags)) {
              warn("FreeImage_Save failed (format '%d', image type '%d')", fif, fit);
            }
          }
        }
        XPUSHs(ST(0)); /* return self */
    }

pdl*
palette_to_pdl(PDL::IO::Image self)
    CODE:
    {
        pdl *pal_pdl = NULL;
        PDL_Indx dims[] = {0, 0, 0};
        int cu = FreeImage_GetColorsUsed(self->dib);
        if (cu==0) XSRETURN_UNDEF;

        PDL_Byte *pdata;
        int i;
        dims[0] = 3;
        dims[1] = cu;
        pal_pdl = PDL->pdlnew();
        pal_pdl->datatype = PDL_B;
        PDL->setdims (pal_pdl, dims, 2);
        PDL->allocdata (pal_pdl);
        pdata = (PDL_Byte *) pal_pdl->data;
        RGBQUAD *pal = FreeImage_GetPalette(self->dib);
        for (i = 0; i < cu; i++) {
          pdata[i*3]     = (PDL_Byte) pal[i].rgbRed;
          pdata[i*3 + 1] = (PDL_Byte) pal[i].rgbGreen;
          pdata[i*3 + 2] = (PDL_Byte) pal[i].rgbBlue;
        }
        RETVAL = pal_pdl;
    }
    OUTPUT:
        RETVAL

pdl*
pixels_to_pdl(PDL::IO::Image self, long x1=0, long x2=0, long y1=0, long y2=0)
    CODE:
    {
        pdl *bmp_pdl = NULL;
        PDL_Indx dims[] = {0, 0, 0};
        PDL_Indx x, y, wxh;
        unsigned long w, h, wp, hp;
        int bpp, it;

        w   = FreeImage_GetWidth(self->dib);
        h   = FreeImage_GetHeight(self->dib);
        bpp = FreeImage_GetBPP(self->dib);
        it  = FreeImage_GetImageType(self->dib);
        wp  = w;
        hp  = h;

        if (!FreeImage_HasPixels(self->dib) || w == 0 || h == 0) {
          warn("FAIL: no pixels");
          XSRETURN_UNDEF;
        }

        /* handle negative boundaries */
        if (x1 < 0)  x1 = w - 1 + x1;
        if (y1 < 0)  y1 = h - 1 + y1;
        if (x2 <= 0) x2 = w - 1 + x2;
        if (y2 <= 0) y2 = h - 1 + y2;
        /* handle region selection */
        wp = (x2 - x1 + 1);
        hp = (y2 - y1 + 1);
        wxh = wp * hp;

        if (x1>x2 || y1>y2 || x1<0 || y1<0 || x2<0 || y2<0 || wp>w || hp>h) {
          warn("FAIL: invalid region");
          XSRETURN_UNDEF;
        }

        switch (it) {
          case FIT_BITMAP:      /* Standard image: 1-, 4-, 8-, 16-, 24-, 32-bit */
            if (bpp==32) {
              PDL_Byte *pdata;
              dims[0] = wp;
              dims[1] = hp;
              dims[2] = 4;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_B;
              PDL->setdims (bmp_pdl, dims, 3);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Byte *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                RGBQUAD *bits = (RGBQUAD*) FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x]         = (PDL_Byte) bits[x+x1].rgbRed;
                  pdata[y*wp + x + wxh]   = (PDL_Byte) bits[x+x1].rgbGreen;
                  pdata[y*wp + x + 2*wxh] = (PDL_Byte) bits[x+x1].rgbBlue;
                  pdata[y*wp + x + 3*wxh] = (PDL_Byte) bits[x+x1].rgbReserved;
                }
              }
            }
            else if (bpp==24) {
              PDL_Byte *pdata;
              dims[0] = wp;
              dims[1] = hp;
              dims[2] = 3;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_B;
              PDL->setdims (bmp_pdl, dims, 3);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Byte *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                RGBTRIPLE *bits = (RGBTRIPLE*) FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x]         = (PDL_Byte) bits[x+x1].rgbtRed;
                  pdata[y*wp + x + wxh]   = (PDL_Byte) bits[x+x1].rgbtGreen;
                  pdata[y*wp + x + 2*wxh] = (PDL_Byte) bits[x+x1].rgbtBlue;
                }
              }
            }
            else if (bpp==16) {
              unsigned red_mask, green_mask, blue_mask;
              PDL_Byte *pdata;
              dims[0] = wp;
              dims[1] = hp;
              dims[2] = 3;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_B;
              PDL->setdims (bmp_pdl, dims, 3);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Byte *) bmp_pdl->data;
              red_mask   = FreeImage_GetRedMask(self->dib);
              green_mask = FreeImage_GetGreenMask(self->dib);
              blue_mask  = FreeImage_GetBlueMask(self->dib);
              if ( (red_mask == FI16_565_RED_MASK) && (green_mask == FI16_565_GREEN_MASK) && (blue_mask == FI16_565_BLUE_MASK) ) {
                for(y = 0; y < hp; y++) {
                  WORD *bits = (WORD*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                  for(x = 0; x < wp; x++) {
                    PDL_Byte r5 = (PDL_Byte)((bits[x+x1] & FI16_565_RED_MASK)   >> FI16_565_RED_SHIFT)  ;
                    PDL_Byte g6 = (PDL_Byte)((bits[x+x1] & FI16_565_GREEN_MASK) >> FI16_565_GREEN_SHIFT);
                    PDL_Byte b5 = (PDL_Byte)((bits[x+x1] & FI16_565_BLUE_MASK)  >> FI16_565_BLUE_SHIFT) ;
                    /* http://stackoverflow.com/questions/2442576/how-does-one-convert-16-bit-rgb565-to-24-bit-rgb888 */
                    pdata[y*wp + x]         = (r5 << 3) | (r5 >> 2);
                    pdata[y*wp + x + wxh]   = (g6 << 2) | (g6 >> 4);
                    pdata[y*wp + x + 2*wxh] = (b5 << 3) | (b5 >> 2);
                  }
                }
              }
              else {
                for(y = 0; y < hp; y++) {
                  WORD *bits = (WORD*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                  for(x = 0; x < wp; x++) {
                    PDL_Byte r5 = (PDL_Byte)((bits[x+x1] & FI16_555_RED_MASK)   >> FI16_555_RED_SHIFT)  ;
                    PDL_Byte g5 = (PDL_Byte)((bits[x+x1] & FI16_555_GREEN_MASK) >> FI16_555_GREEN_SHIFT);
                    PDL_Byte b5 = (PDL_Byte)((bits[x+x1] & FI16_555_BLUE_MASK)  >> FI16_555_BLUE_SHIFT) ;
                    pdata[y*wp + x]         = (r5 << 3) | (r5 >> 2);
                    pdata[y*wp + x + wxh]   = (g5 << 3) | (g5 >> 2);
                    pdata[y*wp + x + 2*wxh] = (b5 << 3) | (b5 >> 2);
                  }
                }
              }
            }
            else if (bpp==8) {
              PDL_Byte *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_B;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Byte *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                BYTE *bits = FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = (PDL_Byte) bits[x+x1];
                }
              }
            }
            else if (bpp==4) {
              PDL_Byte *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_B;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Byte *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                BYTE *bits = FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = (PDL_Byte) ((bits[(x+x1)/2] >> 4*(1-(x+x1)%2)) & 0x0F);
                }
              }
            }
            else if (bpp==1) {
              PDL_Byte *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_B;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Byte *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                BYTE *bits = FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = (PDL_Byte) ((bits[(x+x1)/8] >> (7-(x+x1)%8)) & 0x01);
                }
              }
            }
            else {
              warn("FAIL: unknown bits per pixel '%d'", bpp);
            }
            break;
          case FIT_UINT16:      /* Array of unsigned short: unsigned 16-bit */
            {
              PDL_Ushort *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_US;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Ushort *) bmp_pdl->data;

              for(y = 0; y < hp; y++) {
                PDL_Ushort *bits = (PDL_Ushort*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = bits[x+x1];
                }
              }
            }
            break;
          case FIT_INT16:       /* Array of short: signed 16-bit */
            {
              PDL_Short *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_S;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Short *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                PDL_Short *bits = (PDL_Short*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = bits[x+x1];
                }
              }
            }
            break;
          case FIT_UINT32:      /* Array of unsigned long: unsigned 32-bit */
            { /* XXX hack: using INT64 for UINT32 */
              PDL_LongLong *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_LL;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_LongLong *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                DWORD *bits = (DWORD*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = (PDL_LongLong)bits[x+x1];
                }
              }
            }
            break;
          case FIT_INT32:       /* Array of long: signed 32-bit */
            {
              PDL_Long *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_L;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Long *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                PDL_Long *bits = (PDL_Long*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = bits[x+x1];
                }
              }
            }
            break;
          case FIT_FLOAT:       /* Array of float: 32-bit IEEE floating point */
            {
              PDL_Float *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_F;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Float *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                PDL_Float *bits = (PDL_Float*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = bits[x+x1];
                }
              }
            }
            break;
          case FIT_DOUBLE:      /* Array of double: 64-bit IEEE floating point */
            {
              PDL_Double *pdata;
              dims[0] = wp;
              dims[1] = hp;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_D;
              PDL->setdims (bmp_pdl, dims, 2);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Double *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                PDL_Double *bits = (PDL_Double*)FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x] = bits[x+x1];
                }
              }
            }
            break;
          case FIT_COMPLEX:     /* Array of FICOMPLEX: 2 x 64-bit IEEE floating point */
            warn("FAIL: FIT_COMPLEX not supported");
            /* for(y = 0; y < hp; y++) {
             *   FICOMPLEX *bits = (FICOMPLEX *)FreeImage_GetScanLine(self->dib, h-y-1-y1);
             *   for(x = 0; x < wp; x++) {
             *     pdata[y*wp + x] = (PDL_Double) bits[x+x1].r;
             *     pdata[y*wp + x] = (PDL_Double) bits[x+x1].i;
             *   }
             * }
             */
            break;
          case FIT_RGB16:       /* 48-bit RGB image: 3 x 16-bit */
            {
              PDL_Ushort *pdata;
              dims[0] = wp;
              dims[1] = hp;
              dims[2] = 3;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_US;
              PDL->setdims (bmp_pdl, dims, 3);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Ushort *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                FIRGB16 *bits = (FIRGB16*) FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x]         = (PDL_Ushort) bits[x+x1].red;
                  pdata[y*wp + x + wxh]   = (PDL_Ushort) bits[x+x1].green;
                  pdata[y*wp + x + 2*wxh] = (PDL_Ushort) bits[x+x1].blue;
                }
              }
            }
            break;
          case FIT_RGBA16:      /* 64-bit RGBA image: 4 x 16-bit */
            {
              PDL_Ushort *pdata;
              dims[0] = wp;
              dims[1] = hp;
              dims[2] = 4;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_US;
              PDL->setdims (bmp_pdl, dims, 3);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Ushort *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                FIRGBA16 *bits = (FIRGBA16*) FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x]         = (PDL_Ushort) bits[x+x1].red;
                  pdata[y*wp + x + wxh]   = (PDL_Ushort) bits[x+x1].green;
                  pdata[y*wp + x + 2*wxh] = (PDL_Ushort) bits[x+x1].blue;
                  pdata[y*wp + x + 3*wxh] = (PDL_Ushort) bits[x+x1].alpha;
                }
              }
            }
            break;
          case FIT_RGBF:        /* 96-bit RGB float image: 3 x 32-bit IEEE floating point */
            {
              PDL_Float *pdata;
              dims[0] = wp;
              dims[1] = hp;
              dims[2] = 3;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_F;
              PDL->setdims (bmp_pdl, dims, 3);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Float *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                FIRGBF *bits = (FIRGBF*) FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x]         = (PDL_Float) bits[x+x1].red;
                  pdata[y*wp + x + wxh]   = (PDL_Float) bits[x+x1].green;
                  pdata[y*wp + x + 2*wxh] = (PDL_Float) bits[x+x1].blue;
                }
              }
            }
            break;
          case FIT_RGBAF:       /* 128-bit RGBA float image: 4 x 32-bit IEEE floating point */
            {
              PDL_Float *pdata;
              dims[0] = wp;
              dims[1] = hp;
              dims[2] = 4;
              bmp_pdl = PDL->pdlnew();
              bmp_pdl->datatype = PDL_F;
              PDL->setdims (bmp_pdl, dims, 3);
              PDL->allocdata (bmp_pdl);
              pdata = (PDL_Float *) bmp_pdl->data;
              for(y = 0; y < hp; y++) {
                FIRGBAF *bits = (FIRGBAF*) FreeImage_GetScanLine(self->dib, h-y-1-y1);
                for(x = 0; x < wp; x++) {
                  pdata[y*wp + x]         = (PDL_Float) bits[x+x1].red;
                  pdata[y*wp + x + wxh]   = (PDL_Float) bits[x+x1].green;
                  pdata[y*wp + x + 2*wxh] = (PDL_Float) bits[x+x1].blue;
                  pdata[y*wp + x + 3*wxh] = (PDL_Float) bits[x+x1].alpha;
                }
              }
            }
            break;
          default:
            warn("FAIL: unknown image type '%d'", it);
            break;
        }

        if (bmp_pdl == NULL) XSRETURN_UNDEF;
        RETVAL = bmp_pdl;
    }
    OUTPUT:
        RETVAL

void
DESTROY(PDL::IO::Image self)
    CODE:
        if (self->dib != NULL) FreeImage_Unload(self->dib);
        Safefree(self);


MODULE = PDL::IO::Image PACKAGE = PDL PREFIX=pdl_run_



#line 573 "/usr/lib64/perl5/PDL/PP.pm"
BOOT:
   PDL_COMMENT("Get pointer to structure of core shared C routines")
   PDL_COMMENT("make sure PDL::Core is loaded")
#line 1706 "Image.xs"
   perl_require_pv ("PDL/Core.pm"); /* make sure PDL::Core is loaded */
#ifndef aTHX_
#define aTHX_
#endif
   if (SvTRUE (ERRSV)) Perl_croak(aTHX_ "%s",SvPV_nolen (ERRSV));
   SV* CoreSV = perl_get_sv("PDL::SHARE",FALSE); /* var with core structure */
   if (!CoreSV)
     Perl_croak(aTHX_ "We require the PDL::Core module, which was not found");
   if (!(PDL = INT2PTR(Core*,SvIV( CoreSV )))) /* Core* value */
     Perl_croak(aTHX_ "Got NULL pointer for PDL");
   if (PDL->Version != PDL_CORE_VERSION)
     Perl_croak(aTHX_ "[PDL->Version: %ld PDL_CORE_VERSION: %ld XS_VERSION: %s] PDL::IO::Image needs to be recompiled against the newly installed PDL", (long int)PDL->Version, (long int)PDL_CORE_VERSION, XS_VERSION);
